<template>
    <div>
        <el-card class="el-card">
            <el-form :inline="true" :model="filterQuery"
                     class="query-form" size="mini">
                <el-row>
                    <el-form-item class="query-form-item">
                        <el-input
                            v-model="filterQuery.billNo"
                            placeholder="单据号"
                            clearable
                        ></el-input>
                    </el-form-item>
                    <el-form-item class="query-form-item">
                        <span style="color: #000; margin-left: 10px; margin-right: 6px">单据日期:</span>
                        <el-date-picker
                            :picker-options="pickerOptions"
                            v-model="actDateRange"
                            type="daterange"
                            format="yyyy 年 MM 月 dd 日"
                            value-format="yyyy-MM-dd"
                            range-separator="至"
                            start-placeholder="开始日期"
                            end-placeholder="结束日期"
                        >
                        </el-date-picker>
                    </el-form-item>
                    <el-form-item>
                        <el-button-group style="display:flex;">
                            <el-button type="primary" icon="el-icon-refresh" @click="onReset"></el-button>
                            <el-button type="primary" icon="search" @click="onSubmitFind">查询</el-button>
                            <el-button type="primary" icon="search" @click="newDistributionForm()" :loading="loading">
                                新增采购计划
                            </el-button>
                        </el-button-group>

                    </el-form-item>
                </el-row>
            </el-form>
            <el-table v-loading="loading" :data="list" style="width: 100%" highlight-current-row="true"
                      @current-change="handleDetail">
                <el-table-column label="序号" type="index" width="60"></el-table-column>
                <el-table-column label="单据号" prop="billNo"></el-table-column>
                <el-table-column label="采购日期" prop="billDate">
                    <template slot-scope="scope">
                        <span>{{ parseTime(scope.row.billDate, '{y}-{m}-{d}') }}</span>
                    </template>
                </el-table-column>
                <el-table-column label="采购员" prop="createByName"></el-table-column>
                <el-table-column label="采购仓库" prop="invName"></el-table-column>
                <el-table-column label="采购分库" prop="subInvName"></el-table-column>
                <el-table-column label="采购说明" prop="remark"></el-table-column>
                <el-table-column label="状态" prop="status">
                    <template slot-scope="scope">
                        <el-tag :type="(scope.row.status) | statusFilterType">
                            {{ statusMap[scope.row.status] }}
                        </el-tag>
                    </template>
                </el-table-column>


                <el-table-column label="操作" fixed="right">
                    <template slot-scope="scope">
                        <!-- <el-button type="text" size="small" @click.native.stop="submitOrder(scope.row)"
                        >提交
                        </el-button> -->
                        <el-button
                            type="text"
                            size="small"
                            @click.native="newDistributionForm(scope.$index, scope.row)"
                        >编辑
                        </el-button
                        >
                        <el-button type="text" size="small" @click.native.stop="deleteDialog(scope.row)"
                        >删除
                        </el-button>
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination
                :page-size="filterQuery.limit"
                @current-change="handleCurrentChange"
                layout="prev, pager, next"
                :total="total"
                :current-page="filterQuery.page"
            ></el-pagination>
        </el-card>
        <el-card class="el-card">
            <el-table v-loading="loading" :data="detailList" style="width: 100%">
                <el-table-column label="序号" type="index" width="120"></el-table-column>
                <!-- <el-table-column label="产品编码" prop="productId"></el-table-column> -->
                <el-table-column label="产品通用名" prop="productName" show-overflow-tooltip="true"></el-table-column>
                <el-table-column label="规格型号" prop="spec" show-overflow-tooltip="true"></el-table-column>
                <el-table-column label="申购数量" prop="count"></el-table-column>
                <el-table-column label="注册/备案凭证号" prop="zczbhhzbapzbh" show-overflow-tooltip="true"></el-table-column>
                <el-table-column label="生产企业" prop="manufactory" show-overflow-tooltip="true"></el-table-column>
                <el-table-column label="医疗器械注册人" prop="ylqxzcrbarmc" show-overflow-tooltip="true"></el-table-column>
                <el-table-column label="供应商" prop="supName" show-overflow-tooltip="true"></el-table-column>
            </el-table>
        </el-card>

        <el-dialog
            :title="formMap[formName]"
            :visible.sync="newSpDistributionVisible"
            width="80%"
            v-if="newSpDistributionVisible"
            @close='closeDialog'
            :close-on-click-modal="false"
            :close-on-press-escape="false"
        >
            <purPlanEdit
                :closeDialog="closeDialog"
                :idQuery="idQuery"
            ></purPlanEdit>
        </el-dialog>
    </div>
</template>
<script>
import purPlanEdit from "./purPlanEditDialog";
import {delApply, inserThrOrderWeb, listPlan, listApplyDetail} from "@/api/purchase/purPlan";

export default {
    data() {
        return {
            filterQuery: {
                billAction: null,
                billNo: "",
                originType: null,
                thirdSysFk: "",
                page: 1,
                limit: 10,
                corpName: null,
                type: 1,
                editStatus: 1,
            },
            formName: null,
            formMap: {
                add: "新增采购计划",
                update: "编辑采购计划",
            },
            statusMap: {
                1: "草稿",
                2: "未审核",
                3: "已审核",
                4: "已拒绝"
            },
            idQuery: {},
            total: 0,
            thirdSys: [],
            thirdSysDetail: null,
            busTypes: [],
            originTypes: [],
            list: [],
            detailList: [],
            loading: false,
            actDateRange: [],
            newSpDistributionVisible: false,
            pickerOptions: {
                shortcuts: [
                    {
                        text: "最近一周",
                        onClick(picker) {
                            const end = new Date();
                            const start = new Date();
                            start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
                            picker.$emit("pick", [start, end]);
                        },
                    },
                    {
                        text: "最近一个月",
                        onClick(picker) {
                            const end = new Date();
                            const start = new Date();
                            start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
                            picker.$emit("pick", [start, end]);
                        },
                    },
                    {
                        text: "最近三个月",
                        onClick(picker) {
                            const end = new Date();
                            const start = new Date();
                            start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
                            picker.$emit("pick", [start, end]);
                        },
                    },
                ],
            },
        };
    },

    methods: {
        onReset() {
            this.$router.push({
                path: "",
            });
            this.filterQuery = {
                billNo: "",
                thirdSysFk: "",
                billFlag: null,
                billAction: null,
                startDate: null,
                endDate: null,
                page: 1,
                limit: 10,
                corpName: null,
                type: 1,
                editStatus: 1,
            };
            this.actDateRange = [];
            this.getList();
        },

        onSubmitFind() {
            this.filterQuery.page = 1;
            this.getList();
        },

        getList() {
            if (this.actDateRange != null) {
                this.filterQuery.startDate = this.actDateRange[0];
                this.filterQuery.endDate = this.actDateRange[1];
            } else {
                this.filterQuery.startDate = null;
                this.filterQuery.endDate = null;
            }
            this.loading = true;
            listPlan(this.filterQuery)
                .then((response) => {
                    if (response.code == 20000) {
                        this.list = response.data.list || [];
                        this.total = response.data.total || 0;
                    } else {
                        this.$message.error(response.message);
                    }
                    this.loading = false;
                })
                .catch(() => {
                    this.loading = false;
                    this.list = [];
                    this.total = 0;
                });
        },
        handleDetail(row) {
            let query = {orderIdFk: row.id};
            this.loading = true;
            listApplyDetail(query) //查找该单号下的所有条码
                .then((response) => {
                    this.detailList = response.data.list || [];
                    this.loading = false;
                })
                .catch(() => {
                    this.loading = false;
                    this.detailList = [];
                    this.total = 0;
                });
        },
        submitOrder(row) {
            this.$confirm("是否确定提交审核?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    this.loading = true;
                    let tQuery = {
                        editStatus: 2,
                        purPlanEntity: row,
                    }
                    inserThrOrderWeb(tQuery)
                        .then(response => {
                            this.loading = false;
                            if (response.code === 20000) {
                                this.$message.success("提交成功！");
                                this.getList();
                            } else {
                                this.$message.error(response.message);
                            }
                        })
                        .catch(() => {
                            this.loading = false;
                        })
                })
                .catch(() => {
                });
        },
        deleteDialog(row) {
            this.$confirm("此操作将永久删除该单据, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
            })
                .then(() => {
                    delApply(row.id)
                        .then((response) => {
                            this.loading = false;
                            if (response.code == 20000) {
                                this.$message.success("删除成功");
                                this.getList();
                            } else {
                                this.$message.error(response.message);
                            }
                        })
                        .catch(() => {
                            this.loading = false;
                        });

                })
                .catch(() => {
                });
        },
        handleCurrentChange(val) {
            this.filterQuery.page = val;
            this.getList();
        },

        closeDialog() {
            this.newSpDistributionVisible = false;
            this.getList();
            this.detailList = [];
        },


        newDistributionForm(index, row) {
            this.idQuery.id = '';
            if (this.$isNotBlank(row) && this.$isNotBlank(row.id)) {
                this.idQuery.id = row.id;
                this.idQuery.formData = row;
                this.formName = "update";
            } else
                this.formName = "add";
            this.newSpDistributionVisible = true;
        },

    }
    ,
    components: {
        purPlanEdit,
    }
    ,
    filters: {
        statusFilterType(status) {
            const statusMap = {
                1: "warning",
                2: "success",
            };
            return statusMap[status];
        }
        ,
    }
    ,
    mounted() {
    }
    ,
    created() {
        let end = new Date();
        let start = new Date();
        start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
        this.actDateRange = [start, end];
        this.getList();
    }
    ,
}
;
</script>
<style scoped>
.itemTag {
    float: left;
    text-align: left;
    margin-top: 10px;
    width: 25%;
}

.text {
    font-size: 13px;
    font-family: "Microsoft YaHei";
}

.query-form-item {
    display: block !important;
    margin-right: 10px;
    margin-bottom: 5px;
}

.el-row {
    display: flex;
    flex-wrap: wrap;
}

.el-col {
    border-radius: 4px;
    flex-wrap: wrap;
}
</style>

